'************************************************
' File:   HotKeyDetective.vbs (WSH 5.6, VBScript) 
' Author:  (c) Gnter Born
'
' Lists all shortcut files and their properties found.
' Modified version for Internet Explorer 6.0/WSH 5.6
'
' A utility brought to you by G. Born: www.borncity.com
' The module is copyrighted and the property of the author.
' You have the royalty free right to use this module for
' your own purpose. The technology is discussed in the 
' Microsoft Press books:
' 
' Inside Windows Script Host (3. Auflage, MSP Germany)
' Microsoft Windows Script 2.0 Host Developer's Guide (MSP USA)
' Advanced Development with Microsoft Windows Script Host 2.0 (MSP USA)
'
' Disclaimer:
' USE AS-IS AT YOUR OWN RISK - WITHOUT ANY WARRANTY AND 
' SUPPORT! IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY 
' DAMAGE OR CONSEQUENCES FROM THE USE OF THIS MODULE.
'
' Important: Changed to fit Internet Explorer's modified
' security model shipped with IE SP1. The file HotKeyDetective.htm
' is now mandatory.
'************************************************
Option Explicit

Const Title = "HotKey-Detective V 3.00 by (c) G. Born www.borncity.com"
Const min = 0
Const max = 100

' declare variables
Dim oIE, oIEdoc     ' global IE object reference
Dim valx, i, j, k, item, files

Dim WshShell, oArgs
Dim fso, fi, fc, f
Dim text, text1, sysf, fldr

' Needed for Shortcut method
Set WsHShell = WScript.CreateObject("WScript.Shell")

Set fso = Wscript.CreateObject("Scripting.FileSystemObject")

text = ""
valx = 0   ' init value
files = 0
MakeBar            ' create progress bar

' check folders
RecFolder Wshshell.SpecialFolders("Desktop")
RecFolder Wshshell.SpecialFolders("AllUsersDesktop")
RecFolder Wshshell.SpecialFolders("Startmenu")
RecFolder Wshshell.SpecialFolders("AllUsersStartmenu")

' commented out, because needed to display results
'oIE.Quit                ' Terminate Progress Window

ShowMSIE text, Title    ' show item list in browser window

'### Helper ###
Sub RecFolder (path)
' Processing folder recursive (to get subfolders)
 Dim oFolders, oSubFolder, oFolder

 If path = "" then Exit Sub ' exit on empty paths

 ProcessFiles (path) ' process files in current folder

 Set oFolders = fso.GetFolder(path)  ' get folders
 Set oSubFolder = oFolders.SubFolders
 For Each oFolder in oSubFolder   ' process subfolders recursive
  Call RecFolder (path & "\" & oFolder.name)
 Next

 Set oFolders = Nothing ' release variable 
 Set oSubFolder = Nothing
End Sub

Sub ProcessFiles (folder)
' Check all files in a folder for shortcuts 
 Progress folder, files, Valx, min, max ' show we are still working
 Set fldr = fso.Getfolder(folder)
 Set fc = fldr.Files
 For Each f In fc
  files = files + 1
  If IsLnk(f) Then CheckEntry text, f  ' read properties
 Next
End Sub

Function IsLnk(name)
' check whether file is LNK file
IsLnk = (InstrRev(UCase(name), ".LNK")<>0)
End Function

Sub ShowMSIE (txt, title)
 Dim oDoc
' commented out, because object is still available
' create Internet Browser application object
' Set oIE = WScript.CreateObject("InternetExplorer.Application")
' set (new) browser window properties
 oIE.left=20                    ' window position
 oIE.top = 50                   ' and other properties
 oIE.height = 380
 oIE.width = 580
 oIE.menubar = 0                ' no menu
 oIE.toolbar = 0
 oIE.statusbar = 0
 oIE.navigate ("about:blank")   ' create an empty HTML document 
 oIE.visible = 1                ' keep MSIE visible
 
 While(oIE.Busy): Wend          ' Important: Wait till MSIE ready
 
 Set oDoc = oIE.Document        ' get document object
 oDoc.open                      ' open document
                                ' write script into the document object
 If Txt = "" Then Txt = "No hot keys found"
 oDoc.writeln ("<html><head><title>" & title & "</title></head>")
 oDoc.writeln ("<body>" & Txt & "</body></html>")
 oDoc.close                     ' close document for write access
End Sub

Sub CheckEntry (txt, file)
Dim oLnk
' Add entries with Shortcut parameters
' txt = txt & "<br><i>" &  file & "</i><br>"  ' add file name with path

' Try to create a shortcut file on the given location
' using the CreateShortcut method, if we use no save
' method, no update is done
 Set oLnk = WSHShell.CreateShortcut (file)
 If oLnk.Hotkey <> "" Then _
  txt = txt & "<b>" & oLnk.Hotkey & "</b> " & file & "<br>"
 Set oLnk = Nothing
End Sub
'#### Interface ####
Sub MakeBar ()
' Launch Internet Explorer, prepare a 
' page with a progress bar.

' *** launch Internet Explorer ***
Set oIE = WScript.CreateObject("InternetExplorer.Application")
  oIE.left=50             ' window position
  oIE.top = 100           ' and other properties
  oIE.height = 180
  oIE.width = 480
  oIE.menubar = 0         ' no menu
  oIE.toolbar = 0
  oIE.statusbar = 0
  oIE.navigate Getpath() & "ProgressHelper.htm" ' helper form for progress bar
  oIE.visible = 1         ' keep visible

' Important: wait till MSIE is ready
  Do While (oIE.Busy)
   WScript.Sleep 100      
  Loop
End Sub

Sub Progress(path, f, x, min, max)
' max. 200 pixel range
 
 With oIE.Document.all
  x = x + 1     ' fake progress
  If x < min Then x = min
  If x > max Then x = min
 ' calculate value
  .T1.width = 200 * x / (max-min)
' show value
  .T2.InnerHTML= "Processing: " & x & " % files: " & f & _
                 "<br>path: " & path
 End With
End Sub

Function GetPath()
' Hole Skriptpfad
 Dim path
 path = WScript.ScriptFullName
 GetPath = Left(path, InstrRev(path, "\"))
End Function
'*End      
